//+------------------------------------------------------------------+
//|                                                  expert watl.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                        Based on version of original author giapel|
//|                                    Fixed and improved by Enforcer|
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, giapel/Enforcer"
#property link      "http://www.metaquotes.net"


#include <stdlib.mqh>


//Indicator settings
extern int     High_period         = 80;
extern int     Low_period          = 30;
extern int     Trigger_Sens        = 2;
extern int     BarsToCalc          = 24;
//Orders settings
extern int     TrailingStop        = 100;    //start trailig after x pips
extern int     TSstep              = 10;     //move SL every x pips beyond TrailingStop 
extern double  TakeProfit          = 0;      // set 0 to not use TP
extern bool    AutoSL              = true;   //true= use min/max for SL
extern double  StopLoss            = 0;      // StopLoss in pips. Can be used only if AutoSL=false, set 0 to not use SL
extern int     Slippage            = 4;
extern int     MagicNumber         = 1212;
extern bool    ManageSL            = true;   // changing SL on min/max, request AutoSL = true
//Money management
extern double  Lots                = 0.01;   // Lot size if MM = false
extern bool    MM                  = true;
extern double  RiskPercent         = 1;      // Risk Factor
//Trading scheduler
extern bool    UseTradingHours     = false;    //enable/disable trading scheduler except Avoid_NFP
extern bool    Session_1           = false;
extern int     StartHour1          = 0;      // Start trades after time
extern int     StopHour1           = 6;      // Stop trading after time
extern bool    Session_2            = true;
extern int     StartHour2          = 6;      // Start trades after time
extern int     StopHour2           = 15;     // Stop trading after time
extern bool    Session_3           = false;
extern int     StartHour3          = 15;     // Start trades after time
extern int     StopHour3           = 22;     // Stop trading after time
extern bool    Avoid_NFP           = true;   //No trades on first friday of month.

extern bool    ResetVariables      = false;   //Delete GlobalVariables on exit


//variabili globali
int MaxOrders = 1;
//variabili interne
double value2,value1;
double max,max_prec,min,min_prec,minimo,massimo,minimo2,massimo2;
double max2,max_prec2,min2,min_prec2;
double TP,SL,Price;
int  gap;
double SLbuy,SLsell;

bool change_max,change_min;
bool change_max2,change_min2;
bool change_max_exit,change_min_exit;
bool YesStop;

int BuyStopOrder,SellStopOrder;
double opensellprice,openbuyprice;

double lowlimit,highlimit;
bool modTSbuy,modTSsell;

string GName="_L";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if(IsTesting())GName="_T";
if(Digits == 3 || Digits == 5){
        TrailingStop       *= 10;
        TSstep             *= 10;
        TakeProfit         *= 10;
        StopLoss           *= 10;
        Slippage           *= 10;
        }

   gap         = MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
   value2      = 0;
   max         = 0;
   max_prec    = 0;
   min         = 0;
   min_prec    = 0;
   change_min = false;
   change_max = false;
   lowlimit = 0;
   highlimit = 999;
   modTSbuy = false;
   modTSsell= false;
   SLbuy = 0;
   SLsell = 0;
   
   /*if (!GlobalVariableCheck(Symbol()+"_min1"+GName))
   GlobalVariableSet(Symbol()+"_min1"+GName,0);
   else minimo = GlobalVariableGet(Symbol()+"_min1"+GName);
   
   if (!GlobalVariableCheck(Symbol()+"_max1"+GName))
   GlobalVariableSet(Symbol()+"_max1"+GName,0);
   else massimo = GlobalVariableGet(Symbol()+"_max1"+GName);
   
   if (!GlobalVariableCheck(Symbol()+"_min2"+GName))
   GlobalVariableSet(Symbol()+"_min2"+GName,0);
   else minimo2 = GlobalVariableGet(Symbol()+"_min2"+GName);
   
   if (!GlobalVariableCheck(Symbol()+"_max2"+GName))
   GlobalVariableSet(Symbol()+"_max2"+GName,0);
   else massimo2 = GlobalVariableGet(Symbol()+"_max2"+GName);*/
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
if(ResetVariables){
   GlobalVariableDel(Symbol()+"_max1"+GName);
   GlobalVariableDel(Symbol()+"_max2"+GName);
   GlobalVariableDel(Symbol()+"_min1"+GName);
   GlobalVariableDel(Symbol()+"_min2"+GName);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   if(TrailingStop>0) TrailingStop();

//----
for(int i=1;i<BarsToCalc;i++){
   value2=iCustom(NULL,0,"WATL",High_period,Low_period,Trigger_Sens,1,i);
   value1=iCustom(NULL,0,"WATL",High_period,Low_period,Trigger_Sens,2,i);
   
   if(value1!=0 && value1>lowlimit  && value1<iClose(NULL,0,i)) lowlimit  = value1-gap*Point;
   if(value1!=0 && value1<highlimit && value1>iClose(NULL,0,i)) highlimit = value1+gap*Point;
   
   if(value2!=0 && value2>iOpen(NULL,0,i)){
      //max_prec = max;
      max=iHigh(NULL,0,i);
      i=BarsToCalc;
      value2 = 0;
      massimo2 = GlobalVariableGet(Symbol()+"_max2"+GName);
      massimo = GlobalVariableGet(Symbol()+"_max1"+GName);
      if(max!=massimo){
            massimo2 = massimo;
            massimo = max;
            GlobalVariableSet(Symbol()+"_max1"+GName,massimo);
            GlobalVariableSet(Symbol()+"_max2"+GName,massimo2);            
            change_max = true;
            change_max_exit = true;
      }      
   }   
   if(value2!=0 && value2<iOpen(NULL,0,i)){
      //min_prec = min;
      min=iLow(NULL,0,i);
      i=BarsToCalc;
      value2 = 0;
      minimo2 = GlobalVariableGet(Symbol()+"_min2"+GName);
      minimo = GlobalVariableGet(Symbol()+"_min1"+GName);
      if(min!=minimo){
            minimo2 = minimo;
            minimo = min;
            GlobalVariableSet(Symbol()+"_min1"+GName,minimo);     
            GlobalVariableSet(Symbol()+"_min2"+GName,minimo2);        
            change_min = true;
            change_min_exit = true;
      }      
   }   
} 

Comment("\nmassimo attuale:  ",massimo,"          massimo precedente:  ",massimo2,
        "\nminimo  attuale:  ",minimo,"           minimo  precedente:  ",minimo2,
        "\nlowlimit :  ",lowlimit,"        highlimit: ",highlimit,
        "\nmodTSbuy :  ",modTSbuy,"        modTSsell: ",modTSsell);



//---------------code added 18/03/09 manage SL 
if(ManageSL){
      if(SLbuy!=0)  SL = SLbuy;
      if(SLsell!=0) SL = SLsell;
      if(MyOrders(1)>0 && lowlimit>SL && lowlimit<Bid ) {
            ControlStopPosition();
            if(!modTSbuy) 
            HandleOpenPositions(lowlimit);
      } 
      if(MyOrders(2)>0 && highlimit<SL && highlimit>Ask ) {
            ControlStopPosition();
            if(!modTSsell)
            HandleOpenPositions(highlimit);
      }
      if(MyOrders(1)<1) {lowlimit  = 0;modTSbuy = false;SLbuy = 0;}
      if(MyOrders(2)<1) {highlimit = 999;modTSsell = false;SLsell = 0;}     
}      
//-----------------------------------------------------------
if(MyOrdersLim(1)>0 && (minimo<minimo2 )) {CloseOrderLim(1);}
if(MyOrdersLim(2)>0 && (massimo>massimo2)){CloseOrderLim(2);}

if(MyOrders(1)>0 && (min>openbuyprice  || (change_max && massimo<massimo2))) CloseOrder(1);                          
if(MyOrders(2)>0 && (max<opensellprice || (change_min && minimo>minimo2  ))) CloseOrder(2);

if(min!=0 && TimeToTrade()){
      if(change_max  && MyOrders(2)<MaxOrders && massimo<massimo2){
            TP=0;SL=0;
            Price = minimo-gap*Point;
            if(Bid-Price<=gap*Point) Price=Bid-gap*Point;
            if(TakeProfit>0) TP = minimo-TakeProfit*Point;
            if(AutoSL) SL = massimo;
            else if(StopLoss>0){
               SL = Price + (StopLoss * Point);
            }
                  if(MyOrdersLim(2)<MaxOrders ) OrderSend(Symbol(),OP_SELLSTOP,Lot(),Price,Slippage,SL,TP,"sell",MagicNumber,0,Red);
                  change_max = false;
                  opensellprice = minimo;
      }            
}                               

if(max!=0 && TimeToTrade()){
      if(change_min  && MyOrders(1)<MaxOrders && minimo>minimo2){
            TP=0;SL=0;
            Price = massimo+gap*Point;
            if(Price-Ask<=gap*Point) Price= Ask+gap*Point;
            if(TakeProfit>0)TP=massimo+TakeProfit*Point; 
            if(AutoSL) SL = minimo;
            else if(StopLoss>0){
               SL = Price - (StopLoss * Point);
            }
                  if(MyOrdersLim(1)<MaxOrders ) OrderSend(Symbol(),OP_BUYSTOP,Lot(),Price,Slippage,SL,TP,"buy",MagicNumber,0,Blue);
                  change_min = false;
                  openbuyprice = massimo;
      }            
}                               

   
//----
   return(0);
}
//+------------------------------------------------------------------+

// procedure e funzioni
// funzione per restituire il numero ordini in essere
int MyOrders(int tipo)
{
   int count;
   int Type_Ord;
   int Ord_Total;
   Ord_Total = OrdersTotal();
   if(Ord_Total > 0) {
      for(int i = Ord_Total-1;i >= 0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUY  && tipo == 1) {count++;}
         if(Type_Ord == OP_SELL && tipo == 2) {count++;}
      }
   }
   return(count);
}
int MyOrdersLim(int tipo)
{
   int count;
   int Type_Ord;
   int Ord_Total;
   Ord_Total = OrdersTotal();
   if(Ord_Total > 0) {
      for(int i = Ord_Total-1;i >= 0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUYSTOP  && tipo == 1) count++;
         if(Type_Ord == OP_SELLSTOP && tipo == 2) count++;
      }
   }
   return(count);
}

//procedura per la chiusura degli ordini pendenti
void CloseOrder(int tipo)
{   
    int Type_Ord;
    for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
    {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUY  && tipo == 1) OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Blue);
         if(Type_Ord == OP_SELL && tipo == 2) OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
    }

}

void CloseOrderLim(int tipo)
{   
    int Type_Ord;
    for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
    {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUYSTOP  && tipo == 1) OrderDelete(OrderTicket(),Blue);
         if(Type_Ord == OP_SELLSTOP && tipo == 2) OrderDelete(OrderTicket(),Red);
    }

}

void ControlStopPosition(){
	for ( int z = OrdersTotal() - 1; z >= 0; z -- ){
	     OrderSelect( z, SELECT_BY_POS );
		   if ( OrderSymbol() != Symbol() ) continue;
      	//if ( OrderMagicNumber() != aMagic ) continue;
   		switch ( OrderType() ){
		    	//case OP_BUY:		BuyOrder			= OrderOpenPrice(); break;
			   //case OP_SELL:		SellOrder		= OrderOpenPrice(); break;
			   case OP_BUYSTOP:	BuyStopOrder	= OrderTicket(); break;
			   case OP_SELLSTOP:	SellStopOrder	= OrderTicket(); break;
		   }
    }
}

int HandleModifyStop(int ord_ticket,double op, double price,double tp, color mColor)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,mColor))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " );
         if (err>0) CloseCnt++;
       }
    }
}

int HandleOpenPositions(double sl)
{
   int cnt;
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() == OP_BUY)
               HandleModifyStop(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),LightGreen);

      if(OrderType() == OP_SELL)
      {
               HandleModifyStop(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),LightGreen);
      }
   }
} 


void TrailingStop()
{
if(TSstep<1) TSstep=1;
   RefreshRates();
    for(int i=0;i<OrdersTotal();i++)
    {
       OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
       {
         if(OrderType() == OP_BUY)
         {
               if(Bid-OrderOpenPrice()>Point*TrailingStop && (OrderStopLoss()+(Point*TSstep)<Bid-(Point*TrailingStop)||OrderStopLoss()==0))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(Point*TrailingStop),OrderTakeProfit(),0,Blue);
               SLbuy = OrderStopLoss();
               modTSbuy = true;
               }
         }
         else if(OrderType() == OP_SELL)
         {
               if(OrderOpenPrice()-Ask>Point*TrailingStop && (OrderStopLoss()-(Point*TSstep)>Ask+(Point*TrailingStop)||OrderStopLoss()==0))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(Point*TrailingStop),OrderTakeProfit(),0,Red);
               SLsell = OrderStopLoss();
               modTSsell = true;
               }
         }
       }
    }
    return;
}


double Lot()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double res;
   int LotDigit;

   if (lot_step==1)    LotDigit=0;
   if (lot_step==0.1)  LotDigit=1;
   if (lot_step==0.01) LotDigit=2;

   if (MM) res=AccountFreeMargin()/100000*RiskPercent;
   else res=Lots;
   res=NormalizeDouble(res/lot_step,0)*lot_step;
   if(res<lot_min) res=lot_min;
   if(res>lot_max) res=lot_max;
   return(res);
}

bool TimeToTrade()
{
   bool result = false;
   datetime Session1=NULL;
   datetime Session2=NULL;
   datetime Session3=NULL;
   datetime Session1end=NULL;
   datetime Session2end=NULL;
   datetime Session3end=NULL;
   
   if(UseTradingHours){
   if(Session_1) {
     Session1    = StrToTime(TimeCurrent()+" "+StartHour1);
     Session1end = StrToTime(TimeCurrent()+" "+StopHour1);
   }
   if(Session_2) {
      Session2 = StrToTime(TimeCurrent()+" "+StartHour2);
      Session2end = StrToTime(TimeCurrent()+" "+StopHour2);
   }
   if(Session_3) {
      Session3 = StrToTime(TimeCurrent()+" "+StartHour3);
      Session3end = StrToTime(TimeCurrent()+" "+StopHour3);
   }

      if((TimeCurrent()>= Session1 && TimeCurrent() <= Session1end) ||
         (TimeCurrent()>= Session2 && TimeCurrent() <= Session2end) ||
         (TimeCurrent()>= Session3 && TimeCurrent() <= Session3end))
         result=true;
   }else result=true;
   
   if(Avoid_NFP && DayOfWeek()==5 && Day()<8)result=false;//first friday of month
   
   return(result);
}